Index: contrib/ntp/ntpdc/ntpdc-opts.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc-opts.c	(版本 314126)
+++ contrib/ntp/ntpdc/ntpdc-opts.c	(版本 316722)
@@ -1,7 +1,7 @@
 /*
  *  EDIT THIS FILE WITH CAUTION  (ntpdc-opts.c)
  *
- *  It has been AutoGen-ed  November 21, 2016 at 08:02:18 AM by AutoGen 5.18.5
+ *  It has been AutoGen-ed  March 21, 2017 at 10:44:44 AM by AutoGen 5.18.5
  *  From the definitions    ntpdc-opts.def
  *  and the template file   options
  *
@@ -18,7 +18,7 @@
  * The ntpdc program is copyrighted and licensed
  * under the following terms:
  *
- *  Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.
+ *  Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.
  *  This is free software. It is licensed for use, modification and
  *  redistribution under the terms of the NTP License, copies of which
  *  can be seen at:
@@ -50,7 +50,7 @@
 #endif
 extern FILE * option_usage_fp;
 #define zCopyright      (ntpdc_opt_strs+0)
-#define zLicenseDescrip (ntpdc_opt_strs+341)
+#define zLicenseDescrip (ntpdc_opt_strs+342)
 
 /*
  *  global included definitions
@@ -68,15 +68,15 @@
 /**
  *  static const strings for ntpdc options
  */
-static char const ntpdc_opt_strs[1911] =
-/*     0 */ "ntpdc 4.2.8p9\n"
-            "Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n"
+static char const ntpdc_opt_strs[1914] =
+/*     0 */ "ntpdc 4.2.8p10\n"
+            "Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n"
             "This is free software. It is licensed for use, modification and\n"
             "redistribution under the terms of the NTP License, copies of which\n"
             "can be seen at:\n"
             "  <http://ntp.org/license>\n"
             "  <http://opensource.org/licenses/ntp-license.php>\n\0"
-/*   341 */ "Permission to use, copy, modify, and distribute this software and its\n"
+/*   342 */ "Permission to use, copy, modify, and distribute this software and its\n"
             "documentation for any purpose with or without fee is hereby granted,\n"
             "provided that the above copyright notice appears in all copies and that\n"
             "both the copyright notice and this permission notice appear in supporting\n"
@@ -86,56 +86,56 @@
             "Time Foundation makes no representations about the suitability this\n"
             "software for any purpose.  It is provided \"as is\" without express or\n"
             "implied warranty.\n\0"
-/*  1009 */ "Force IPv4 DNS name resolution\0"
-/*  1040 */ "IPV4\0"
-/*  1045 */ "ipv4\0"
-/*  1050 */ "Force IPv6 DNS name resolution\0"
-/*  1081 */ "IPV6\0"
-/*  1086 */ "ipv6\0"
-/*  1091 */ "run a command and exit\0"
-/*  1114 */ "COMMAND\0"
-/*  1122 */ "command\0"
-/*  1130 */ "Increase debug verbosity level\0"
-/*  1161 */ "DEBUG_LEVEL\0"
-/*  1173 */ "debug-level\0"
-/*  1185 */ "Set the debug verbosity level\0"
-/*  1215 */ "SET_DEBUG_LEVEL\0"
-/*  1231 */ "set-debug-level\0"
-/*  1247 */ "Force ntpq to operate in interactive mode\0"
-/*  1289 */ "INTERACTIVE\0"
-/*  1301 */ "interactive\0"
-/*  1313 */ "Print a list of the peers\0"
-/*  1339 */ "LISTPEERS\0"
-/*  1349 */ "listpeers\0"
-/*  1359 */ "numeric host addresses\0"
-/*  1382 */ "NUMERIC\0"
-/*  1390 */ "numeric\0"
-/*  1398 */ "PEERS\0"
-/*  1404 */ "peers\0"
-/*  1410 */ "Show a list of the peers\0"
-/*  1435 */ "SHOWPEERS\0"
-/*  1445 */ "showpeers\0"
-/*  1455 */ "display extended usage information and exit\0"
-/*  1499 */ "help\0"
-/*  1504 */ "extended usage information passed thru pager\0"
-/*  1549 */ "more-help\0"
-/*  1559 */ "output version information and exit\0"
-/*  1595 */ "version\0"
-/*  1603 */ "save the option state to a config file\0"
-/*  1642 */ "save-opts\0"
-/*  1652 */ "load options from a config file\0"
-/*  1684 */ "LOAD_OPTS\0"
-/*  1694 */ "no-load-opts\0"
-/*  1707 */ "no\0"
-/*  1710 */ "NTPDC\0"
-/*  1716 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p9\n"
+/*  1010 */ "Force IPv4 DNS name resolution\0"
+/*  1041 */ "IPV4\0"
+/*  1046 */ "ipv4\0"
+/*  1051 */ "Force IPv6 DNS name resolution\0"
+/*  1082 */ "IPV6\0"
+/*  1087 */ "ipv6\0"
+/*  1092 */ "run a command and exit\0"
+/*  1115 */ "COMMAND\0"
+/*  1123 */ "command\0"
+/*  1131 */ "Increase debug verbosity level\0"
+/*  1162 */ "DEBUG_LEVEL\0"
+/*  1174 */ "debug-level\0"
+/*  1186 */ "Set the debug verbosity level\0"
+/*  1216 */ "SET_DEBUG_LEVEL\0"
+/*  1232 */ "set-debug-level\0"
+/*  1248 */ "Force ntpq to operate in interactive mode\0"
+/*  1290 */ "INTERACTIVE\0"
+/*  1302 */ "interactive\0"
+/*  1314 */ "Print a list of the peers\0"
+/*  1340 */ "LISTPEERS\0"
+/*  1350 */ "listpeers\0"
+/*  1360 */ "numeric host addresses\0"
+/*  1383 */ "NUMERIC\0"
+/*  1391 */ "numeric\0"
+/*  1399 */ "PEERS\0"
+/*  1405 */ "peers\0"
+/*  1411 */ "Show a list of the peers\0"
+/*  1436 */ "SHOWPEERS\0"
+/*  1446 */ "showpeers\0"
+/*  1456 */ "display extended usage information and exit\0"
+/*  1500 */ "help\0"
+/*  1505 */ "extended usage information passed thru pager\0"
+/*  1550 */ "more-help\0"
+/*  1560 */ "output version information and exit\0"
+/*  1596 */ "version\0"
+/*  1604 */ "save the option state to a config file\0"
+/*  1643 */ "save-opts\0"
+/*  1653 */ "load options from a config file\0"
+/*  1685 */ "LOAD_OPTS\0"
+/*  1695 */ "no-load-opts\0"
+/*  1708 */ "no\0"
+/*  1711 */ "NTPDC\0"
+/*  1717 */ "ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p10\n"
             "Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n\0"
-/*  1846 */ "$HOME\0"
-/*  1852 */ ".\0"
-/*  1854 */ ".ntprc\0"
-/*  1861 */ "http://bugs.ntp.org, bugs@ntp.org\0"
-/*  1895 */ "\n\0"
-/*  1897 */ "ntpdc 4.2.8p9";
+/*  1848 */ "$HOME\0"
+/*  1854 */ ".\0"
+/*  1856 */ ".ntprc\0"
+/*  1863 */ "http://bugs.ntp.org, bugs@ntp.org\0"
+/*  1897 */ "\n\0"
+/*  1899 */ "ntpdc 4.2.8p10";
 
 /**
  *  ipv4 option description with
@@ -142,11 +142,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the ipv4 option */
-#define IPV4_DESC      (ntpdc_opt_strs+1009)
+#define IPV4_DESC      (ntpdc_opt_strs+1010)
 /** Upper-cased name for the ipv4 option */
-#define IPV4_NAME      (ntpdc_opt_strs+1040)
+#define IPV4_NAME      (ntpdc_opt_strs+1041)
 /** Name string for the ipv4 option */
-#define IPV4_name      (ntpdc_opt_strs+1045)
+#define IPV4_name      (ntpdc_opt_strs+1046)
 /** Other options that appear in conjunction with the ipv4 option */
 static int const aIpv4CantList[] = {
     INDEX_OPT_IPV6, NO_EQUIVALENT };
@@ -158,11 +158,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the ipv6 option */
-#define IPV6_DESC      (ntpdc_opt_strs+1050)
+#define IPV6_DESC      (ntpdc_opt_strs+1051)
 /** Upper-cased name for the ipv6 option */
-#define IPV6_NAME      (ntpdc_opt_strs+1081)
+#define IPV6_NAME      (ntpdc_opt_strs+1082)
 /** Name string for the ipv6 option */
-#define IPV6_name      (ntpdc_opt_strs+1086)
+#define IPV6_name      (ntpdc_opt_strs+1087)
 /** Other options that appear in conjunction with the ipv6 option */
 static int const aIpv6CantList[] = {
     INDEX_OPT_IPV4, NO_EQUIVALENT };
@@ -173,11 +173,11 @@
  *  command option description:
  */
 /** Descriptive text for the command option */
-#define COMMAND_DESC      (ntpdc_opt_strs+1091)
+#define COMMAND_DESC      (ntpdc_opt_strs+1092)
 /** Upper-cased name for the command option */
-#define COMMAND_NAME      (ntpdc_opt_strs+1114)
+#define COMMAND_NAME      (ntpdc_opt_strs+1115)
 /** Name string for the command option */
-#define COMMAND_name      (ntpdc_opt_strs+1122)
+#define COMMAND_name      (ntpdc_opt_strs+1123)
 /** Compiled in flag settings for the command option */
 #define COMMAND_FLAGS     (OPTST_DISABLED | OPTST_STACKED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_STRING))
@@ -186,11 +186,11 @@
  *  debug-level option description:
  */
 /** Descriptive text for the debug-level option */
-#define DEBUG_LEVEL_DESC      (ntpdc_opt_strs+1130)
+#define DEBUG_LEVEL_DESC      (ntpdc_opt_strs+1131)
 /** Upper-cased name for the debug-level option */
-#define DEBUG_LEVEL_NAME      (ntpdc_opt_strs+1161)
+#define DEBUG_LEVEL_NAME      (ntpdc_opt_strs+1162)
 /** Name string for the debug-level option */
-#define DEBUG_LEVEL_name      (ntpdc_opt_strs+1173)
+#define DEBUG_LEVEL_name      (ntpdc_opt_strs+1174)
 /** Compiled in flag settings for the debug-level option */
 #define DEBUG_LEVEL_FLAGS     (OPTST_DISABLED)
 
@@ -198,11 +198,11 @@
  *  set-debug-level option description:
  */
 /** Descriptive text for the set-debug-level option */
-#define SET_DEBUG_LEVEL_DESC      (ntpdc_opt_strs+1185)
+#define SET_DEBUG_LEVEL_DESC      (ntpdc_opt_strs+1186)
 /** Upper-cased name for the set-debug-level option */
-#define SET_DEBUG_LEVEL_NAME      (ntpdc_opt_strs+1215)
+#define SET_DEBUG_LEVEL_NAME      (ntpdc_opt_strs+1216)
 /** Name string for the set-debug-level option */
-#define SET_DEBUG_LEVEL_name      (ntpdc_opt_strs+1231)
+#define SET_DEBUG_LEVEL_name      (ntpdc_opt_strs+1232)
 /** Compiled in flag settings for the set-debug-level option */
 #define SET_DEBUG_LEVEL_FLAGS     (OPTST_DISABLED \
         | OPTST_SET_ARGTYPE(OPARG_TYPE_NUMERIC))
@@ -212,11 +212,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the interactive option */
-#define INTERACTIVE_DESC      (ntpdc_opt_strs+1247)
+#define INTERACTIVE_DESC      (ntpdc_opt_strs+1248)
 /** Upper-cased name for the interactive option */
-#define INTERACTIVE_NAME      (ntpdc_opt_strs+1289)
+#define INTERACTIVE_NAME      (ntpdc_opt_strs+1290)
 /** Name string for the interactive option */
-#define INTERACTIVE_name      (ntpdc_opt_strs+1301)
+#define INTERACTIVE_name      (ntpdc_opt_strs+1302)
 /** Other options that appear in conjunction with the interactive option */
 static int const aInteractiveCantList[] = {
     INDEX_OPT_COMMAND,
@@ -231,11 +231,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the listpeers option */
-#define LISTPEERS_DESC      (ntpdc_opt_strs+1313)
+#define LISTPEERS_DESC      (ntpdc_opt_strs+1314)
 /** Upper-cased name for the listpeers option */
-#define LISTPEERS_NAME      (ntpdc_opt_strs+1339)
+#define LISTPEERS_NAME      (ntpdc_opt_strs+1340)
 /** Name string for the listpeers option */
-#define LISTPEERS_name      (ntpdc_opt_strs+1349)
+#define LISTPEERS_name      (ntpdc_opt_strs+1350)
 /** Other options that appear in conjunction with the listpeers option */
 static int const aListpeersCantList[] = {
     INDEX_OPT_COMMAND, NO_EQUIVALENT };
@@ -246,11 +246,11 @@
  *  numeric option description:
  */
 /** Descriptive text for the numeric option */
-#define NUMERIC_DESC      (ntpdc_opt_strs+1359)
+#define NUMERIC_DESC      (ntpdc_opt_strs+1360)
 /** Upper-cased name for the numeric option */
-#define NUMERIC_NAME      (ntpdc_opt_strs+1382)
+#define NUMERIC_NAME      (ntpdc_opt_strs+1383)
 /** Name string for the numeric option */
-#define NUMERIC_name      (ntpdc_opt_strs+1390)
+#define NUMERIC_name      (ntpdc_opt_strs+1391)
 /** Compiled in flag settings for the numeric option */
 #define NUMERIC_FLAGS     (OPTST_DISABLED)
 
@@ -259,11 +259,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the peers option */
-#define PEERS_DESC      (ntpdc_opt_strs+1313)
+#define PEERS_DESC      (ntpdc_opt_strs+1314)
 /** Upper-cased name for the peers option */
-#define PEERS_NAME      (ntpdc_opt_strs+1398)
+#define PEERS_NAME      (ntpdc_opt_strs+1399)
 /** Name string for the peers option */
-#define PEERS_name      (ntpdc_opt_strs+1404)
+#define PEERS_name      (ntpdc_opt_strs+1405)
 /** Other options that appear in conjunction with the peers option */
 static int const aPeersCantList[] = {
     INDEX_OPT_COMMAND, NO_EQUIVALENT };
@@ -275,11 +275,11 @@
  *  "Must also have options" and "Incompatible options":
  */
 /** Descriptive text for the showpeers option */
-#define SHOWPEERS_DESC      (ntpdc_opt_strs+1410)
+#define SHOWPEERS_DESC      (ntpdc_opt_strs+1411)
 /** Upper-cased name for the showpeers option */
-#define SHOWPEERS_NAME      (ntpdc_opt_strs+1435)
+#define SHOWPEERS_NAME      (ntpdc_opt_strs+1436)
 /** Name string for the showpeers option */
-#define SHOWPEERS_name      (ntpdc_opt_strs+1445)
+#define SHOWPEERS_name      (ntpdc_opt_strs+1446)
 /** Other options that appear in conjunction with the showpeers option */
 static int const aShowpeersCantList[] = {
     INDEX_OPT_COMMAND, NO_EQUIVALENT };
@@ -289,11 +289,11 @@
 /*
  *  Help/More_Help/Version option descriptions:
  */
-#define HELP_DESC       (ntpdc_opt_strs+1455)
-#define HELP_name       (ntpdc_opt_strs+1499)
+#define HELP_DESC       (ntpdc_opt_strs+1456)
+#define HELP_name       (ntpdc_opt_strs+1500)
 #ifdef HAVE_WORKING_FORK
-#define MORE_HELP_DESC  (ntpdc_opt_strs+1504)
-#define MORE_HELP_name  (ntpdc_opt_strs+1549)
+#define MORE_HELP_DESC  (ntpdc_opt_strs+1505)
+#define MORE_HELP_name  (ntpdc_opt_strs+1550)
 #define MORE_HELP_FLAGS (OPTST_IMM | OPTST_NO_INIT)
 #else
 #define MORE_HELP_DESC  HELP_DESC
@@ -306,14 +306,14 @@
 #  define VER_FLAGS     (OPTST_SET_ARGTYPE(OPARG_TYPE_STRING) | \
                          OPTST_ARG_OPTIONAL | OPTST_IMM | OPTST_NO_INIT)
 #endif
-#define VER_DESC        (ntpdc_opt_strs+1559)
-#define VER_name        (ntpdc_opt_strs+1595)
-#define SAVE_OPTS_DESC  (ntpdc_opt_strs+1603)
-#define SAVE_OPTS_name  (ntpdc_opt_strs+1642)
-#define LOAD_OPTS_DESC     (ntpdc_opt_strs+1652)
-#define LOAD_OPTS_NAME     (ntpdc_opt_strs+1684)
-#define NO_LOAD_OPTS_name  (ntpdc_opt_strs+1694)
-#define LOAD_OPTS_pfx      (ntpdc_opt_strs+1707)
+#define VER_DESC        (ntpdc_opt_strs+1560)
+#define VER_name        (ntpdc_opt_strs+1596)
+#define SAVE_OPTS_DESC  (ntpdc_opt_strs+1604)
+#define SAVE_OPTS_name  (ntpdc_opt_strs+1643)
+#define LOAD_OPTS_DESC     (ntpdc_opt_strs+1653)
+#define LOAD_OPTS_NAME     (ntpdc_opt_strs+1685)
+#define NO_LOAD_OPTS_name  (ntpdc_opt_strs+1695)
+#define LOAD_OPTS_pfx      (ntpdc_opt_strs+1708)
 #define LOAD_OPTS_name     (NO_LOAD_OPTS_name + 3)
 /**
  *  Declare option callback procedures
@@ -522,24 +522,24 @@
 
 /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
 /** Reference to the upper cased version of ntpdc. */
-#define zPROGNAME       (ntpdc_opt_strs+1710)
+#define zPROGNAME       (ntpdc_opt_strs+1711)
 /** Reference to the title line for ntpdc usage. */
-#define zUsageTitle     (ntpdc_opt_strs+1716)
+#define zUsageTitle     (ntpdc_opt_strs+1717)
 /** ntpdc configuration file name. */
-#define zRcName         (ntpdc_opt_strs+1854)
+#define zRcName         (ntpdc_opt_strs+1856)
 /** Directories to search for ntpdc config files. */
 static char const * const apzHomeList[3] = {
-    ntpdc_opt_strs+1846,
-    ntpdc_opt_strs+1852,
+    ntpdc_opt_strs+1848,
+    ntpdc_opt_strs+1854,
     NULL };
 /** The ntpdc program bug email address. */
-#define zBugsAddr       (ntpdc_opt_strs+1861)
+#define zBugsAddr       (ntpdc_opt_strs+1863)
 /** Clarification/explanation of what ntpdc does. */
-#define zExplain        (ntpdc_opt_strs+1895)
+#define zExplain        (ntpdc_opt_strs+1897)
 /** Extra detail explaining what ntpdc does. */
 #define zDetail         (NULL)
 /** The full version string for ntpdc. */
-#define zFullVersion    (ntpdc_opt_strs+1897)
+#define zFullVersion    (ntpdc_opt_strs+1899)
 /* extracted from optcode.tlib near line 364 */
 
 #if defined(ENABLE_NLS)
@@ -796,8 +796,8 @@
      translate option names.
    */
   /* referenced via ntpdcOptions.pzCopyright */
-  puts(_("ntpdc 4.2.8p9\n\
-Copyright (C) 1992-2016 The University of Delaware and Network Time Foundation, all rights reserved.\n\
+  puts(_("ntpdc 4.2.8p10\n\
+Copyright (C) 1992-2017 The University of Delaware and Network Time Foundation, all rights reserved.\n\
 This is free software. It is licensed for use, modification and\n\
 redistribution under the terms of the NTP License, copies of which\n\
 can be seen at:\n"));
@@ -862,7 +862,7 @@
   puts(_("load options from a config file"));
 
   /* referenced via ntpdcOptions.pzUsageTitle */
-  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p9\n\
+  puts(_("ntpdc - vendor-specific NTPD control program - Ver. 4.2.8p10\n\
 Usage:  %s [ -<flag> [<val>] | --<name>[{=| }<val>] ]... [ host ...]\n"));
 
   /* referenced via ntpdcOptions.pzExplain */
@@ -869,7 +869,7 @@
   puts(_("\n"));
 
   /* referenced via ntpdcOptions.pzFullVersion */
-  puts(_("ntpdc 4.2.8p9"));
+  puts(_("ntpdc 4.2.8p10"));
 
   /* referenced via ntpdcOptions.pzFullUsage */
   puts(_("<<<NOT-FOUND>>>"));
Index: contrib/ntp/ntpdc/ntpdc.c
===================================================================
--- contrib/ntp/ntpdc/ntpdc.c	(版本 314126)
+++ contrib/ntp/ntpdc/ntpdc.c	(版本 316722)
@@ -649,7 +649,7 @@
 	todiff = (((uint32_t)time(NULL)) - tobase) & 0x7FFFFFFFu;
 	if ((n > 0) && (todiff > tospan)) {
 		n = recv(sockfd, (char *)&rpkt, sizeof(rpkt), 0);
-		n = 0; /* faked timeout return from 'select()'*/
+		n -= n; /* faked timeout return from 'select()'*/
 	}
 	
 	if (n == 0) {
Index: contrib/ntp/ntpq/Makefile.am
===================================================================
--- contrib/ntp/ntpq/Makefile.am	(版本 314126)
+++ contrib/ntp/ntpq/Makefile.am	(版本 316722)
@@ -6,12 +6,15 @@
 sbin_PROGRAMS=	$(NTPQ_DS)
 
 AM_CFLAGS = $(CFLAGS_NTP)
+AM_CFLAGS += $(NTP_HARD_CFLAGS)
 
 AM_CPPFLAGS  = $(NTP_INCS)
 AM_CPPFLAGS += $(LIBOPTS_CFLAGS)
 AM_CPPFLAGS += $(CPPFLAGS_NTP)
+AM_CPPFLAGS += $(NTP_HARD_CPPFLAGS)
 
-AM_LDFLAGS = $(LDFLAGS_NTP)
+AM_LDFLAGS  = $(LDFLAGS_NTP)
+AM_LDFLAGS += $(NTP_HARD_LDFLAGS)
 
 # LDADD might need RESLIB and ADJLIB
 ntpq_LDADD  = version.o $(LIBOPTS_LDADD)
